// JChatDialog.cpp : implementation file
//

#include "stdafx.h"
#include "LanChatClientCOM.h"
#include "JChatDialog.h"

#include "JChatClient.h"
#include ".\ChatProtocol\JChatProtocol.h"
#include "JServerInfoDlg.h"
#include "JMakeRoomDlg.h"
#include "JEnterRoomDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// JChatDialog dialog


JChatDialog::JChatDialog(CWnd* pParent /*=NULL*/)
	: CDialog(JChatDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(JChatDialog)
	//}}AFX_DATA_INIT
}


void JChatDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(JChatDialog)
	DDX_Control(pDX, IDC_LISTMAN, listUser);
	DDX_Control(pDX, IDC_LISTCONV, listConv);
	DDX_Control(pDX, IDC_EDITCONV, strConv);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(JChatDialog, CDialog)
	//{{AFX_MSG_MAP(JChatDialog)
	ON_BN_CLICKED(ID_MAKEROOM, OnMakeroom)
	ON_BN_CLICKED(ID_ENTERROOM, OnEnterroom)
	ON_BN_CLICKED(ID_OUTROOM, OnOutroom)
	ON_BN_CLICKED(IDC_SILENTWORD, OnSilentword)
	ON_LBN_SELCHANGE(IDC_LISTMAN, OnSelchangeListman)
	ON_EN_SETFOCUS(IDC_EDITCONV, OnSetfocusEditconv)
	//}}AFX_MSG_MAP
	ON_MESSAGE( WM_EDIT_RETURN, OnEditReturn )
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// JChatDialog message handlers

void JChatDialog::setState_disconnect()
{
	GetDlgItem( ID_MAKEROOM )->EnableWindow( false );
	GetDlgItem( ID_ENTERROOM )->EnableWindow( false );
	GetDlgItem( ID_OUTROOM )->EnableWindow( false );

	listConv.EnableWindow( false );
	listUser.EnableWindow( false );
	strConv.EnableWindow( false );
	GetDlgItem( IDC_SILENTWORD )->EnableWindow( false );

	listConv.ResetCount();

	LoginID = "";
	curChannel = "";
	bConnected = false;
	clntSock = NULL;
	editProcess = NMBITSET;
}

void JChatDialog::setState_connect()
{
	listConv.ResetCount();
	listUser.ResetContent();
	strConv.SetWindowText( _T( "" ) );

	listConv.EnableWindow();
	strConv.EnableWindow();

	listUser.EnableWindow( false );
	GetDlgItem( IDC_SILENTWORD )->EnableWindow( false );

	bConnected = true;
}

void JChatDialog::setState_convin()
{
	GetDlgItem( ID_MAKEROOM )->EnableWindow( false );
	GetDlgItem( ID_ENTERROOM )->EnableWindow( false );
	GetDlgItem( ID_OUTROOM )->EnableWindow();

	listConv.ResetCount();
	listUser.ResetContent();
	strConv.SetWindowText( _T( "" ) );
	editProcess = BDIALOG;

	listConv.EnableWindow();
	strConv.EnableWindow();
	listUser.EnableWindow();

	GetDlgItem( IDC_SILENTWORD )->EnableWindow( false );

	strConv.SetFocus();
}

void JChatDialog::setState_convout()
{
	GetDlgItem( ID_MAKEROOM )->EnableWindow();
	GetDlgItem( ID_ENTERROOM )->EnableWindow();
	GetDlgItem( ID_OUTROOM )->EnableWindow( false );

	curChannel = "";

	listConv.EnableWindow( false );
	listUser.EnableWindow( false );
	strConv.EnableWindow( false );
	GetDlgItem( IDC_SILENTWORD )->EnableWindow( false );
}

void JChatDialog::OnMakeroom() 
{
	int retVal;
	JMakeRoomDlg dlg;

	retVal = dlg.DoModal();

	if ( retVal == IDOK ) {
		if ( dlg.strName.Find( _T( "$" ), 0 ) != -1 ) {
			AfxMessageBox( _T( "ȭ ̸ '$' ڴ   ϴ." ) );
			return;
		}

		SendMakeRoom( dlg.strName, dlg.strCode );
	}

	strConv.SetFocus();
}

void JChatDialog::OnEnterroom() 
{
	int retVal;
	JEnterRoomDlg dlg;

	dlg.Init( &svRoom );
	retVal = dlg.DoModal();

	if ( retVal == IDOK ) SendInRoom( dlg.strName, dlg.strCode );	
	else if ( dlg.strName == "Update Channel List" ) {
		AfxMessageBox( _T( "κ ȭ Ʈ  ۵  ð \n ɸϴ.  ٸ  ٽ ư ." ) );
		UpdateChannel();
	}
}

void JChatDialog::OnOutroom() 
{
	setState_convout();
	
	SendOutRoom( curChannel );
}

void JChatDialog::OnSilentword() 
{
	CString in, out;
	CString toName;
	int index;

	index = listUser.GetCurSel();
	if ( index == LB_ERR ) return;
	listUser.GetText( index, toName );

	if ( toName == LoginID ) {
		listConv.AddText( "ڽſ ӼӸ  ϴ." );
		listConv.AddText( "ٸ ڸ ϼ." );
		return;
	}

	strConv.GetWindowText( in );
	if ( !in.GetLength() ) return;
	strConv.SetSel( 0, in.GetLength() );

	out.Format( _T( "%s$%s" ), toName, in );

	listConv.AddText( toName + " Կ ӼӸ : " + in );
	SendSilentWord( out );
}

void JChatDialog::OnSelchangeListman() 
{
	GetDlgItem( IDC_SILENTWORD )->EnableWindow();	
}

// ä  ư  
void JChatDialog::OnOK() 
{
	setState_disconnect();
	clntThread->stop();
	closesocket( clntSock );
	WSACleanup();
	
	CDialog::OnOK();
}

void JChatDialog::OnSetfocusEditconv() 
{
	CString in;
	strConv.GetWindowText( in );
	strConv.SetSel( 0, in.GetLength() );
}

BOOL JChatDialog::DestroyWindow() 
{
	// TODO: Add your specialized code here and/or call the base class
	if ( clntSock ) OnOK();
	
	return CDialog::DestroyWindow();
}

BOOL JChatDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();

	setState_disconnect();

	WSADATA wsaData;
	SOCKADDR_IN sockAddr;

	memset( &sockAddr, 0, sizeof( sockAddr ) );

	WORD wVersionRequested = MAKEWORD( 1, 1 );
	WSAStartup( wVersionRequested, &wsaData );

	JServerInfo info;
	JServerInfoDlg dlg;
	dlg.DoModal();
	info = dlg.Get();

	sockAddr.sin_family = AF_INET;
	sockAddr.sin_addr.s_addr = htonl( INADDR_ANY );
	sockAddr.sin_port = htons( (u_short)info.Port );
	clntSock = socket( AF_INET, SOCK_STREAM, 0 );

	if ( clntSock == INVALID_SOCKET ) {
		MessageBox( _T( "" ), _T( "  ȵ˴ϴ." ), MB_OK );
	}

	bind( clntSock, (SOCKADDR*)&sockAddr, sizeof( sockAddr ) );

	sockAddr.sin_addr.s_addr = inet_addr( info.IP );

	if ( connect( clntSock, (SOCKADDR*)&sockAddr, sizeof( sockAddr ) ) != SOCKET_ERROR ) {
		setState_connect();
		
		CRuntimeClass *prt = RUNTIME_CLASS( JChatClient );
		clntThread = (JChatClient *)AfxBeginThread( prt );
		clntThread->start( &clntSock, this );

		Sleep( 300 );
		send( clntSock, "$CONNECT", COMMANDLENGTH, 0 );
	} else OnOK();
	
	strConv.SetFocus();
	return FALSE;
}

long JChatDialog::OnEditReturn( WPARAM wParam, LPARAM lParam )
{
	CString in;

	strConv.GetWindowText( in );
	in.TrimLeft();
	in.TrimRight();
	
	if ( !in.GetLength() ) return -1;
	strConv.SetSel( 0, in.GetLength() );

	MakeCommand( in );

	return 1L;
}

void JChatDialog::UpdateChannel()
{
	char command[] = "$UPCHANN";

	svRoom.RemoveAll();
	send( clntSock, command, strlen( command ), 0 );
}

CString JChatDialog::GetCurChannel()
{
	return curChannel;
}

void JChatDialog::SetCurChannel( CString myChannel )
{
	curChannel = myChannel;
}

void JChatDialog::SetUserID( CString myLoginID )
{
	LoginID = myLoginID;

	GetDlgItem( ID_MAKEROOM )->EnableWindow();
	GetDlgItem( ID_ENTERROOM )->EnableWindow();
	GetDlgItem( ID_OUTROOM )->EnableWindow( false );
}

CString JChatDialog::GetUserID()
{
	return LoginID;
}

void JChatDialog::AddMeRoom( CString OcurChannel )
{
	curChannel = OcurChannel;
	listUser.AddString( LoginID );
}

void JChatDialog::AddSvRoom( CnvRoom ARoom )
{
	svRoom.Add( ARoom );
}

void JChatDialog::DeleteSvRoom( CString channel )
{
	for ( int i = 0; i < svRoom.GetSize(); i ++ ) {
		if ( svRoom.GetAt( i ).strName == channel ) {
			svRoom.RemoveAt( i );
			return;
		}
	}
}

void JChatDialog::MakeCommand( CString sendText )
{
	if ( editProcess == BLOGIN ) SendLogin( sendText );
	else if ( editProcess == BDIALOG ) {
		SendDialog( sendText );
		return;
	}

	editProcess = NMBITSET;
}

void JChatDialog::SendDialog( CString sendText )
{
	CString head = "$DIALOGX$";
	CString data;

	data.Format( _T( HEADERFORMAT ), sendText.GetLength(), sendText );
	head = head + data;
	send( clntSock, (const char *)( head.operator LPCTSTR() ), head.GetLength(), 0 );
}

void JChatDialog::SendSilentWord( CString sendText )
{
	CString head = "$SILENTW$";
	CString data;

	data.Format( _T( HEADERFORMAT ), sendText.GetLength(), sendText );
	head = head + data;
	send( clntSock, (const char *)( head.operator LPCTSTR() ), head.GetLength(), 0 );
}

void JChatDialog::SendMakeRoom( CString channelName, CString channelCode )
{
	CString head = "$MCHANNE$";
	CString strLen;
	CString data;

	if ( channelCode == "" ) channelCode = "none";

	data.Format( _T( "%s$%s" ), channelName, channelCode );
	strLen.Format( _T( HEADERFORMAT ), data.GetLength(), data );
	head = head + strLen;
	send( clntSock, (const char *)( head.operator LPCTSTR() ), head.GetLength(), 0 );
}

void JChatDialog::SendInRoom( CString channelName, CString channelCode )
{
	CString head = "$ICHANNE$";
	CString strLen;
	CString data;

	strLen.Format( _T( "%s$%s" ), channelName, channelCode );
	data.Format( _T( HEADERFORMAT ), strLen.GetLength(), strLen );
	head = head + data;

	send( clntSock, (const char *)head.operator LPCTSTR(), head.GetLength(), 0 );
}

void JChatDialog::SendOutRoom( CString curChannel )
{
	CString head = "$OCHANNE";

	send( clntSock, (const char *)head.operator LPCTSTR(), head.GetLength(), 0 );
}

void JChatDialog::SendLogin( CString sendText )
{
	CString head = "$LOGINXX$";
	CString data;

	data.Format( _T( HEADERFORMAT ), sendText.GetLength(), sendText );
	head = head + data;
	send( clntSock, (const char *)head.operator LPCTSTR(), head.GetLength(), 0 );
}
