#if !defined(AFX_JCHATDIALOG_H__E2B82B33_6504_11D3_B977_204C4F4F5020__INCLUDED_)
#define AFX_JCHATDIALOG_H__E2B82B33_6504_11D3_B977_204C4F4F5020__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// JChatDialog.h : header file
//

#include "LanChatClientCOM.h"
#include "JOutputListBox.h"
#include "JInputEdit.h"

#include <afxsock.h>
#include <afxtempl.h>

/////////////////////////////////////////////////////////////////////////////
// JChatDialog dialog

typedef struct tagCnvRoom {
	int numUser;
	CString strName;
	bool bCode;
} CnvRoom;

typedef enum tagSendString {
	BLOGIN,
	BDIALOG,
	NMBITSET
} SendString;

class JChatClient;

class JChatDialog : public CDialog
{
// Construction
public:
	SendString editProcess;
	SOCKET clntSock;

	JChatDialog(CWnd* pParent = NULL);   // standard constructor

	void setState_disconnect();
	void setState_connect();
	void setState_convin();
	void setState_convout();

	void SendMakeRoom( CString channelName, CString channelCode );
	void SendLogin( CString sendText );
	void SendDialog( CString sendText );
	void SendInRoom( CString channelName, CString channelCode );
	void SendOutRoom( CString curChannel );
	void SendSilentWord( CString sendText );

	void AddSvRoom( CnvRoom ARoom );
	void AddMeRoom( CString data );
	void DeleteSvRoom( CString channel );

	void UpdateChannel();
	CString GetUserID();
	void SetUserID( CString myLoginID );
	CString GetCurChannel();
	void SetCurChannel( CString myChannel );

	// Dialog Data
	//{{AFX_DATA(JChatDialog)
	enum { IDD = IDD_CHATVIEWER };
	CListBox	listUser;
	JOutputListBox	listConv;
	JInputEdit	strConv;
	//}}AFX_DATA

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(JChatDialog)
	public:
	virtual BOOL DestroyWindow();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	JChatClient *clntThread;

	CArray<CnvRoom, CnvRoom> svRoom;
	CString LoginID;
	CString curChannel;

	bool bConnected;

	void MakeCommand( CString sendText );

	// Generated message map functions
	//{{AFX_MSG(JChatDialog)
	afx_msg void OnMakeroom();
	afx_msg void OnEnterroom();
	afx_msg void OnOutroom();
	afx_msg void OnSilentword();
	afx_msg void OnSelchangeListman();
	virtual void OnOK();
	afx_msg void OnSetfocusEditconv();
	virtual BOOL OnInitDialog();
	afx_msg long OnEditReturn( WPARAM wParam, LPARAM lParam );
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_JCHATDIALOG_H__E2B82B33_6504_11D3_B977_204C4F4F5020__INCLUDED_)
